package com.zhentao.pojo;

import jakarta.validation.constraints.*;
import lombok.Data;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.Date;

@Data
public class Object1 {
    @NotNull
    private String appId;
    private long createTime=System.currentTimeMillis();
    @NotNull
    private Integer goodsId;
    @NotNull(message = "price not null")
    @DecimalMin(value = "0",message = "最小是0")
    @DecimalMax(value = "9999",message = "最大是9999")
    private BigDecimal price;
    @NotNull
    @Pattern(regexp = "^\\d{11}$", message = "手机号必须是 11 位数字")
    private String mobile;
    @NotNull
    private Date nowDate=new Date();
}
